import { ComponentConstructorInfo, ComponentDrawInfo, DateBy } from '../types';
import Component from '../common/Component';
import { SN } from '../common/definitions';
import AxisBody from '../Axis/AxisBody';
/**
 * @property {Readonly<AxisBodyDrawInfo>} bodyDrawInfo - the DrawInfo of AxisBody.
 * @property {number} alignY - the y point which is the AxisMilestone align target.
 * @property {number} description - the showed description of milestone.
 * */
interface DrawInfo extends ComponentDrawInfo {
    bodyDrawInfo: Readonly<AxisBody['drawInfo']>;
    alignY: number;
    content: string | {
        date: string;
        by: DateBy;
    };
}
/**
 * The milestone on Axis, for indicate time of nearby area.
 * Can conflict with EventBody.
 * */
export default abstract class AxisMilestone extends Component {
    constructor(props: ComponentConstructorInfo);
    name: SN;
    drawInfo: DrawInfo;
    formatDate(date: Date, by: DateBy): string;
    createElement(): import("../common/Component").MUST_CALL_AND_RETURN_SUPER_METHOD;
    createBox(): void;
    apply(): Promise<import("../common/Component").MUST_CALL_AND_RETURN_SUPER_METHOD>;
    draw(): import("../common/Component").MUST_CALL_AND_RETURN_SUPER_METHOD;
    static is(comp: Component): comp is AxisMilestone;
}
export {};
