import Component from '../common/Component';
import { ComponentConstructorInfo, ComponentDrawInfo, Coordinate } from '../types';
import { SN } from '../common/definitions';
import AxisBody from '../Axis/AxisBody';
/**
 * @property {Readonly<AxisBodyDrawInfo>} bodyDrawInfo - the DrawInfo of AxisBody.
 * @property {Coordinate} target - the target coordinate in Axis.
 * @property {width} width - the width of mark.
 * @property {[number]} height - the height of mark.
 * */
interface DrawInfo extends ComponentDrawInfo {
    axisBodyDrawInfo: Readonly<AxisBody['drawInfo']>;
    target: Coordinate;
    width: number;
    height?: number;
}
/**
 * In axis, mark a mark for recognize event point when event take place.
 * Optional, a theme can omit this component by situation.
 * */
export default abstract class EventMark extends Component {
    constructor(props: ComponentConstructorInfo);
    name: SN;
    drawInfo: DrawInfo;
    createBox(): void;
    apply(): Promise<import("../common/Component").MUST_CALL_AND_RETURN_SUPER_METHOD>;
    static is(comp: Component): comp is EventMark;
}
export {};
