"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Component_1 = __importDefault(require("../common/Component"));
var functions_1 = require("../common/functions");
var definitions_1 = require("../common/definitions");
/**
 * The whole Event. Contain an EventBody and an EventMark, maybe has a EventAxis too.
 * The Manage-Component. All of draw is resolved by child component.
 * */
var Event = /** @class */ (function (_super) {
    __extends(Event, _super);
    function Event(props) {
        var _this = _super.call(this, props) || this;
        _this.name = definitions_1.SN.Event;
        // The instances
        _this.mark = null;
        _this.body = null;
        _this.axis = null;
        _this.grid = props.grid;
        _this.drawInfo = {
            target: {
                x: 30,
                y: 50,
            },
            offset: _this.grid.eventOffset,
            date: null,
            title: null,
            folded: false,
            box: {
                x: 0,
                y: 0,
                width: 500,
                height: 500,
            },
            axisBodyDrawInfo: {},
        };
        _this.ext.onConstruct(_this);
        return _this;
    }
    Event.prototype.createBox = function () {
        this.drawInfo.box = functions_1.mergeBox(this.body.drawInfo.box, this.mark.drawInfo.box);
        if (this.axis) {
            this.drawInfo.box = functions_1.mergeBox(this.drawInfo.box, this.axis.drawInfo.box);
        }
    };
    Event.prototype.apply = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.initMark();
                        return [4 /*yield*/, this.mark.apply()];
                    case 1:
                        _a.sent();
                        this.initBody();
                        return [4 /*yield*/, this.body.apply()];
                    case 2:
                        _a.sent();
                        this.initAxis();
                        if (!this.axis) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.axis.apply()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        this.createBox();
                        return [2 /*return*/, _super.prototype.apply.call(this)];
                }
            });
        });
    };
    Event.prototype.draw = function () {
        this.body.draw();
        if (this.axis)
            this.axis.draw();
        this.mark.draw();
        return _super.prototype.draw.call(this);
    };
    Event.prototype.hide = function () {
        this.mark.hide();
        this.body.hide();
        this.axis && this.axis.hide();
        return _super.prototype.hide.call(this);
    };
    Event.prototype.destroy = function () {
        this.mark.destroy();
        this.body.destroy();
        this.axis && this.axis.destroy();
        return _super.prototype.destroy.call(this);
    };
    Event.prototype.initMark = function () {
        if (this.mark)
            this.mark.destroy();
        // @ts-ignore - realize a absolute class that will re-init in the theme.
        this.mark = new this.markConstructor(this);
        this.mark.drawInfo.target = this.drawInfo.target;
        this.mark.drawInfo.width = this.grid.markWidth;
        this.mark.drawInfo.height = this.grid.markHeight;
    };
    Event.prototype.initBody = function () {
        if (this.body)
            this.body.destroy();
        // @ts-ignore - realize a absolute class that will re-init in the theme.
        this.body = new this.bodyConstructor(this);
        this.body.drawInfo.markDrawInfo = functions_1.deepFreeze(this.mark.drawInfo);
        this.body.drawInfo.maxWidth = this.grid.eventWidth;
        this.body.drawInfo.date = this.drawInfo.date;
        this.body.drawInfo.title = this.drawInfo.title;
        this.body.drawInfo.description = this.drawInfo.description;
        this.body.drawInfo.folded = this.drawInfo.folded;
        this.body.drawInfo.foldPlaceholder = this.drawInfo.foldPlaceholder;
        this.body.drawInfo.offset = Object.assign({}, this.drawInfo.offset);
        this.body.drawInfo.endText = this.drawInfo.endText;
        this.body.drawInfo.endDate = this.drawInfo.endDate;
    };
    Event.prototype.initAxis = function () {
        if (this.axis) {
            this.axis.destroy();
            this.axis = null;
        }
        if (this.drawInfo.axisLength) {
            // @ts-ignore - realize a absolute class that will re-init in the theme.
            var axis = this.axis || new this.axisConstructor(this);
            axis.drawInfo.axisBodyDrawInfo = this.drawInfo.axisBodyDrawInfo;
            axis.drawInfo.markDrawInfo = functions_1.deepFreeze(this.mark.drawInfo);
            axis.drawInfo.offsetX = this.grid.minEventAxisOffset;
            axis.drawInfo.length = this.drawInfo.axisLength;
            axis.drawInfo.text = this.drawInfo.endText;
            this.axis = axis;
        }
    };
    Event.is = function (comp) {
        return comp.name === definitions_1.SN.Event;
    };
    return Event;
}(Component_1.default));
exports.default = Event;
//# sourceMappingURL=index.js.map