"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Component_1 = __importDefault(require("./common/Component"));
var definitions_1 = require("./common/definitions");
var BreakpointAnimation_1 = require("./extensions/BreakpointAnimation");
var TimeSpliter_1 = __importDefault(require("./common/TimeSpliter"));
var extensions_1 = require("./extensions");
var functions_1 = require("./common/functions");
var html2canvas_1 = __importDefault(require("html2canvas"));
/**
 * Timeline self. There are 2 way to draw a timeline.
 * 1. draw a timeline base on event list.
 * 2. draw a timeline base an TimelineData.
 * For No.1, there are like:
 * ```js
 * const timeline = new Timeline(...);
 * timeline.event = [...];
 * await timeline.apply();
 * timeline.draw();
 * ```js
 *
 * For No.2, Ensure you had a TimelineData, and run like this for draw a timeline:
 * (The TimelineData is generate by timeline.export())
 * ```js
 * const timeline = new Timeline(...);
 * await timeline.drawFrom(timelineData);
 * ```
 * */
var Timeline = /** @class */ (function (_super) {
    __extends(Timeline, _super);
    function Timeline(props) {
        var _this = _super.call(this, {
            ext: props.ext || new extensions_1.ExtensionManager,
            canvas: props.canvas,
            container: props.container,
        }) || this;
        _this.name = definitions_1.SN.Timeline;
        /**
         * Generated after timeline.apply() called.
         * If you wanna to specify some keys, passed a object when timeline.apply() called.
         * @see RuntimeInfo
         * */
        _this.runtime = {};
        _this.drawInfo = {
            box: { x: 0, y: 0, width: 0, height: 0 },
            events: [],
        };
        // The instances
        _this.events = [];
        _this.axis = null;
        _this.grid = props.grid || Timeline.defaultGrid;
        _this.ext.onConstruct(_this);
        return _this;
    }
    Timeline.prototype.createBox = function () {
        this.drawInfo.box = functions_1.mergeBox.apply(void 0, __spread([this.axis.drawInfo.box], this.events.map(function (event) { return event.drawInfo.box; })));
    };
    /**
     * @param {Partial<RuntimeInfo>} runtime - manually specify some runtime info.
     * */
    Timeline.prototype.apply = function (runtime) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.drawInfo.events.length)
                            throw new Error('No event passed the timeline!');
                        this.initRuntime(runtime);
                        this.stretchCanvas();
                        // @ts-ignore
                        return [4 /*yield*/, this.initAxis()];
                    case 1:
                        // @ts-ignore
                        _a.sent();
                        return [4 /*yield*/, this.axis.apply()];
                    case 2:
                        _a.sent();
                        this.events.forEach(function (e) { return e.destroy(); });
                        this.events.length = 0;
                        this.initEvents();
                        return [4 /*yield*/, Promise.all(this.events.map(function (e) { return e.apply(); }))];
                    case 3:
                        _a.sent();
                        this.createBox();
                        return [2 /*return*/, _super.prototype.apply.call(this)];
                }
            });
        });
    };
    Timeline.prototype.draw = function () {
        this.stretchCanvas();
        this.setupRadio();
        this.axis.draw();
        this.events.forEach(function (event) { return event.draw(); });
        return _super.prototype.draw.call(this);
    };
    Timeline.prototype.hide = function () {
        this.events.forEach(function (event) { return event.hide(); });
        this.axis.hide();
        return _super.prototype.hide.call(this);
    };
    /**
     * Draw a timeline base on a TimelineData.
     * (The TimelineData is generated by timeline.export())
     * @param (TimelineData) input
     * @return {Promise<void>>}
     * */
    Timeline.prototype.import = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var data, axis, event, allComponents, _a, bodyDrawInfo, scalesDrawInfo, milestonesDrawInfo, scalesAndMilestones_1, events, events_1, events_1_1, _b, bodyDrawInfo, markDrawInfo, axisDrawInfo, allComponents_1, allComponents_1_1, comp, e_1_1;
            var e_2, _c, e_1, _d;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        data = typeof input === 'string' ? JSON.parse(input).data : input.data;
                        axis = new this.axisConstructor(this);
                        event = new this.eventConstructor(this);
                        this.canvas.width = data.width;
                        this.canvas.height = data.height;
                        // string to date
                        data.axis.milestonesDrawInfo.forEach(function (milestoneDrawInfo) {
                            if ('date' in milestoneDrawInfo.content) {
                                milestoneDrawInfo.content.date = new Date(milestoneDrawInfo.content.date);
                            }
                        });
                        allComponents = [];
                        {
                            _a = data.axis, bodyDrawInfo = _a.bodyDrawInfo, scalesDrawInfo = _a.scalesDrawInfo, milestonesDrawInfo = _a.milestonesDrawInfo;
                            // @ts-ignore
                            allComponents.push(new axis.bodyConstructor(this).importDrawInfo(bodyDrawInfo));
                            scalesAndMilestones_1 = [];
                            scalesDrawInfo.forEach(function (scaleDrawInfo) {
                                scalesAndMilestones_1.push(
                                // @ts-ignore
                                new axis.scaleConstructor(_this).importDrawInfo(scaleDrawInfo));
                            });
                            milestonesDrawInfo.forEach(function (milestoneDrawInfo) {
                                scalesAndMilestones_1.push(
                                // @ts-ignore
                                new axis.milestoneConstructor(_this).importDrawInfo(milestoneDrawInfo));
                            });
                            scalesAndMilestones_1.sort(function (comp1, comp2) { return comp1.drawInfo.alignY - comp2.drawInfo.alignY; });
                            allComponents.push.apply(allComponents, __spread(scalesAndMilestones_1));
                        }
                        events = Array.from(data.events)
                            .sort(function (e1, e2) { return e1.drawInfo.target.y - e2.drawInfo.target.y; });
                        try {
                            for (events_1 = __values(events), events_1_1 = events_1.next(); !events_1_1.done; events_1_1 = events_1.next()) {
                                _b = events_1_1.value, bodyDrawInfo = _b.bodyDrawInfo, markDrawInfo = _b.markDrawInfo, axisDrawInfo = _b.axisDrawInfo;
                                // @ts-ignore
                                allComponents.push(new event.bodyConstructor(this).importDrawInfo(bodyDrawInfo));
                                if (axisDrawInfo !== null) {
                                    // @ts-ignore
                                    allComponents.push(new event.axisConstructor(this).importDrawInfo(axisDrawInfo));
                                }
                                // @ts-ignore
                                allComponents.push(new event.markConstructor(this).importDrawInfo(markDrawInfo));
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (events_1_1 && !events_1_1.done && (_c = events_1.return)) _c.call(events_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 6, 7, 8]);
                        allComponents_1 = __values(allComponents), allComponents_1_1 = allComponents_1.next();
                        _e.label = 2;
                    case 2:
                        if (!!allComponents_1_1.done) return [3 /*break*/, 5];
                        comp = allComponents_1_1.value;
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.DrawFrom, { protagonist: comp })];
                    case 3:
                        _e.sent();
                        comp.draw();
                        _e.label = 4;
                    case 4:
                        allComponents_1_1 = allComponents_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (allComponents_1_1 && !allComponents_1_1.done && (_d = allComponents_1.return)) _d.call(allComponents_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Export a TimelineData for current timeline.
     * Make sure call timeline.apply() before call this method.
     * @return {TimelineData}
     * */
    Timeline.prototype.export = function () {
        var timeline = this.ext.components[definitions_1.SN.Timeline][0];
        return JSON.parse(JSON.stringify({
            theme: timeline.theme,
            version: definitions_1.SN_VERSION,
            data: {
                width: timeline.canvas.width,
                height: timeline.canvas.height,
                timeline: timeline.drawInfo,
                runtime: timeline.runtime,
                events: timeline.events.map(function (event) { return ({
                    drawInfo: event.drawInfo,
                    bodyDrawInfo: event.body.drawInfo,
                    markDrawInfo: event.mark.drawInfo,
                    axisDrawInfo: event.axis ? event.axis.drawInfo : null,
                }); }),
                axis: {
                    drawInfo: timeline.axis.drawInfo,
                    bodyDrawInfo: timeline.axis.body.drawInfo,
                    scalesDrawInfo: timeline.axis.scales.map(function (scale) { return scale.drawInfo; }),
                    milestonesDrawInfo: timeline.axis.milestones.map(function (milestone) { return milestone.drawInfo; }),
                },
            },
        }));
    };
    /**
     * Generate a pure image base timeline.
     * It's available after after draw() been called
     * */
    Timeline.prototype.screenshot = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                console.log(2, this);
                return [2 /*return*/, html2canvas_1.default(this.container, {
                        scale: Math.max(2, window.devicePixelRatio),
                    })];
            });
        });
    };
    /**
     * Download a timeline image for user
     * It's available after after draw() been called
     * */
    Timeline.prototype.downloadImage = function (filename) {
        if (filename === void 0) { filename = this.theme + "-timeline.png"; }
        return __awaiter(this, void 0, void 0, function () {
            var canvas, a, blob;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.screenshot()];
                    case 1:
                        canvas = _a.sent();
                        a = document.createElement('a');
                        return [4 /*yield*/, new Promise((function (resolve) { return canvas.toBlob(resolve, 'image/png'); }))];
                    case 2:
                        blob = _a.sent();
                        a.target = '_blank';
                        a.download = filename;
                        a.href = window.URL.createObjectURL(blob);
                        a.click();
                        return [2 /*return*/];
                }
            });
        });
    };
    // Stretch the canvas ensure the canvas can contain all of component
    Timeline.prototype.stretchCanvas = function () {
        var e_3, _a;
        this.canvas.width = this.grid.canvasWidth;
        this.canvas.height = this.runtime.axisLength + this.grid.axisStart.y * 2;
        var componentMap = this.ext.components;
        for (var snName in componentMap) {
            try {
                for (var _b = (e_3 = void 0, __values(componentMap[snName])), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var component = _c.value;
                    var box = component.drawInfo.box;
                    this.canvas.height = Math.max(this.canvas.height, box.y + box.height + this.grid.axisStart.y);
                    this.canvas.width = Math.max(this.canvas.width, box.x + box.width);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        this.container.style.width = this.canvas.width + "px";
    };
    // Count runtime info
    Timeline.prototype.initRuntime = function (runtime) {
        this.runtime = Object.create(runtime || Object.prototype);
        this.runtime.startDate = ('startDate' in this.runtime)
            ? functions_1.parseDate(this.runtime.startDate)
            : this.countStartData();
        this.runtime.endDate = ('endDate' in this.runtime)
            ? functions_1.parseDate(this.runtime.endDate)
            : this.countEndData();
        this.runtime.milestoneBy = ('milestoneBy' in this.runtime)
            ? this.runtime.milestoneBy
            : this.countMilestoneBy();
        this.runtime.scaleBy = ('scaleBy' in this.runtime)
            ? this.runtime.scaleBy
            : this.countScaleBy();
        this.runtime.axisLength = ('axisLength' in this.runtime)
            ? this.runtime.axisLength
            : this.countAxisLength();
        // FIXME: What is it???
        // aligning scaleBy
        this.runtime.startDate = functions_1.parseDate(functions_1.parseDate(this.runtime.startDate).getTime()
            - definitions_1.DATE_COUNT_EXTRA[this.runtime.scaleBy || "day" /* Day */]);
        this.runtime.endDate = functions_1.parseDate(functions_1.parseDate(this.runtime.endDate).getTime()
            + definitions_1.DATE_COUNT_EXTRA[this.runtime.scaleBy || "day" /* Day */]);
    };
    Timeline.prototype.countStartData = function () {
        var events = Array.from(this.drawInfo.events).sort(function (e1, e2) { return Number(functions_1.parseDate(e1.date)) - Number(functions_1.parseDate(e2.date)); });
        return functions_1.parseDate(events[0].date);
    };
    Timeline.prototype.countEndData = function () {
        var events = this.drawInfo.events;
        var maxStartData = Math.max.apply(Math, __spread(events.map(function (event) { return Number(functions_1.parseDate(event.date)); })));
        var maxEndData = Math.max.apply(Math, __spread(events
            .filter(function (event) { return ('endDate' in event); })
            .map(function (event) { return Number(functions_1.parseDate(event.endDate)); }))) || -1;
        return functions_1.parseDate(Math.max(maxStartData, maxEndData));
    };
    Timeline.prototype.countMilestoneBy = function () {
        var TWO_WEEK = 1000 * 60 * 60 * 24 * 7 * 2;
        var TWO_MONTH = 1000 * 60 * 60 * 24 * 30 * 2;
        var TWO_QUARTER = 1000 * 60 * 60 * 24 * 30 * 3 * 2;
        var TWO_YEAR = 1000 * 60 * 60 * 24 * 30 * 12 * 2;
        var TWENTY_YEAR = 1000 * 60 * 60 * 24 * 30 * 12 * 20;
        var TWO_CENTURY = 1000 * 60 * 60 * 24 * 30 * 12 * 100 * 2;
        var TWENTY_CENTURY = 1000 * 60 * 60 * 24 * 30 * 12 * 100 * 20;
        var dataScope = functions_1.parseDate(this.runtime.endDate).getTime()
            - functions_1.parseDate(this.runtime.startDate).getTime();
        switch (true) {
            case dataScope > TWENTY_CENTURY:
                return "fiveCentury" /* FiveCentury */;
            case dataScope > TWO_CENTURY:
                return "century" /* Century */;
            case dataScope > TWENTY_YEAR:
                return "tenYear" /* TenYear */;
            case dataScope > TWO_YEAR:
                return "year" /* Year */;
            case dataScope > TWO_QUARTER:
                return "quarter" /* Quarter */;
            case dataScope > TWO_MONTH:
                return "month" /* Month */;
            case dataScope > TWO_WEEK:
                return "week" /* Week */;
        }
        return null;
    };
    Timeline.prototype.countScaleBy = function () {
        switch (this.runtime.milestoneBy) {
            case "fiveCentury" /* FiveCentury */:
                return "century" /* Century */;
            case "century" /* Century */:
                return "tenYear" /* TenYear */;
            case "tenYear" /* TenYear */:
                return "year" /* Year */;
            case "year" /* Year */:
                return "quarter" /* Quarter */;
            case "quarter" /* Quarter */:
                return "month" /* Month */;
            case "month" /* Month */:
                return "week" /* Week */;
            case "week" /* Week */:
                return "day" /* Day */;
        }
        return null;
    };
    Timeline.prototype.countAxisLength = function () {
        var events = this.drawInfo.events;
        return 500
            + events.length * 50
            + events.filter(function (e) { return e.description; }).length * 70
            + events.filter(function (e) { return e.endText; }).length * 30;
    };
    // Create instance
    Timeline.prototype.initAxis = function () {
        var _this = this;
        // @ts-ignore
        if (!this.axis)
            this.axis = new this.axisConstructor(this);
        var startDate = this.runtime.startDate.getTime();
        var endDate = this.runtime.endDate.getTime();
        var timeSpliter = new TimeSpliter_1.default(startDate, endDate);
        var dateLength = endDate - startDate;
        this.axis.drawInfo.length = this.runtime.axisLength;
        if (this.runtime.milestoneBy !== null) {
            this.axis.drawInfo.milestones = timeSpliter
                .split(this.runtime.milestoneBy)
                .map(function (date) { return ({
                position: (endDate - date.getTime())
                    / dateLength,
                content: {
                    date: date.toISOString(),
                    by: _this.runtime.milestoneBy,
                },
            }); });
        }
        if (this.runtime.scaleBy !== null) {
            this.axis.drawInfo.scales = timeSpliter
                .split(this.runtime.scaleBy)
                .map(function (date) {
                return (functions_1.parseDate(_this.runtime.endDate).getTime() - date.getTime())
                    / dateLength;
            });
        }
    };
    Timeline.prototype.initEvents = function () {
        var e_4, _a;
        var events = Array.from(this.drawInfo.events)
            .sort(function (e1, e2) { return functions_1.parseDate(e1.date).getTime() - functions_1.parseDate(e2.date).getTime(); });
        var dateLength = functions_1.parseDate(this.runtime.endDate).getTime()
            - functions_1.parseDate(this.runtime.startDate).getTime();
        try {
            for (var events_2 = __values(events), events_2_1 = events_2.next(); !events_2_1.done; events_2_1 = events_2.next()) {
                var data = events_2_1.value;
                // @ts-ignore
                var event_1 = new this.eventConstructor(this);
                event_1.drawInfo.axisBodyDrawInfo = functions_1.deepFreeze(this.axis.body.drawInfo);
                event_1.drawInfo.target = {
                    x: this.axis.body.drawInfo.box.x + this.axis.body.drawInfo.box.width / 2,
                    y: (functions_1.parseDate(this.runtime.endDate).getTime() - functions_1.parseDate(data.date).getTime())
                        / dateLength
                        * this.axis.drawInfo.length,
                };
                event_1.drawInfo.date = data.date;
                event_1.drawInfo.title = data.title;
                event_1.drawInfo.description = data.description;
                event_1.drawInfo.folded = Boolean(data.folded);
                event_1.drawInfo.foldPlaceholder = data.foldPlaceholder;
                event_1.drawInfo.endText = data.endText;
                if (data.endDate) {
                    var endDate = functions_1.parseDate(data.endDate === 'now'
                        ? this.runtime.endDate
                        : data.endDate);
                    event_1.drawInfo.endDate = endDate.toISOString();
                    event_1.drawInfo.axisLength =
                        (endDate.getTime() - functions_1.parseDate(data.date).getTime())
                            / dateLength
                            * this.axis.drawInfo.length;
                }
                this.events.push(event_1);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (events_2_1 && !events_2_1.done && (_a = events_2.return)) _a.call(events_2);
            }
            finally { if (e_4) throw e_4.error; }
        }
    };
    Timeline.is = function (comp) {
        return comp.name === definitions_1.SN.Timeline;
    };
    /**
     * Mount a HTML element adding canvas and container.
     * The HTML element passed will be cleared.
     * */
    Timeline.mount = function (el, themeName) {
        var container = typeof el === 'string'
            ? document.querySelector(el)
            : el;
        container.innerHTML = '';
        container.classList.add('short-night', themeName, 'container');
        var canvas = document.createElement('canvas');
        canvas.height = 6000;
        canvas.width = 600;
        canvas.classList.add('short-night', themeName, 'canvas');
        container.appendChild(canvas);
        return { container: container, canvas: canvas };
    };
    Timeline.defaultGrid = {
        eventOffset: { x: 20, y: 0 },
        minEventAxisOffset: 25,
        markWidth: 15,
        scaleHeight: 5,
        axisWidth: 12,
        axisStart: {
            x: 450,
            y: 10,
        },
        eventWidth: 300,
        canvasWidth: 700,
    };
    return Timeline;
}(Component_1.default));
exports.default = Timeline;
//# sourceMappingURL=Timeline.js.map