"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var definitions_1 = require("../common/definitions");
/**
 * Create element following comp.drawInfo.box for debug.
 * Using this extension, the development can inspect an Short-Night Component by Web Console.
 * */
var BoxElementGenerator = /** @class */ (function () {
    function BoxElementGenerator(ext) {
        var _this = this;
        this.ext = ext;
        this.type = _1.ExtensionType.DebugOnly;
        if (definitions_1.DEBUG) {
            window.clearBox = function () {
                var e_1, _a;
                var componentMap = _this.ext.components;
                for (var snName in componentMap) {
                    try {
                        for (var _b = (e_1 = void 0, __values(componentMap[snName])), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var component = _c.value;
                            var elt = component.extraData.boxElement;
                            if (elt && elt.parentElement) {
                                elt.parentElement.removeChild(elt);
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
            };
        }
    }
    /**
     * Create a element append to container.
     * The element size equal component.drawInfo.box.
     * */
    BoxElementGenerator.prototype.onApply = function (comp) {
        return __awaiter(this, void 0, void 0, function () {
            var elt, _a, _b, _c, key, value;
            var e_2, _d;
            return __generator(this, function (_e) {
                if (comp.extraData.boxElement && comp.extraData.boxElement.parentElement) {
                    comp.extraData.boxElement.parentElement.removeChild(comp.extraData.boxElement);
                }
                elt = document.createElement(comp.name);
                elt.id = comp.extraData.id;
                try {
                    //  Map every property of component.drawInfo to HTML element data-*.
                    for (_a = __values(Object.entries(comp.drawInfo)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        _c = __read(_b.value, 2), key = _c[0], value = _c[1];
                        if (typeof value === 'undefined')
                            continue;
                        elt.setAttribute(key, JSON.stringify(value));
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                Object.assign(elt.style, {
                    position: 'absolute',
                    left: comp.drawInfo.box.x + "px",
                    top: comp.drawInfo.box.y + "px",
                    width: comp.drawInfo.box.width + "px",
                    height: comp.drawInfo.box.height + "px",
                    zIndex: 2147483647 - ~~(comp.drawInfo.box.width * comp.drawInfo.box.height),
                });
                comp.container.appendChild(elt);
                comp.extraData.boxElement = elt;
                return [2 /*return*/];
            });
        });
    };
    /**
     * Remove element created in onApply.
     * */
    BoxElementGenerator.prototype.onDestroy = function (comp) {
        var elt = comp.extraData.boxElement;
        if (elt && elt.parentElement) {
            elt.parentElement.removeChild(elt);
        }
    };
    return BoxElementGenerator;
}());
exports.default = BoxElementGenerator;
//# sourceMappingURL=BoxElementGenerator.js.map