"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var definitions_1 = require("../../common/definitions");
var functions_1 = require("../../common/functions");
var BreakpointAnimation_1 = require("../BreakpointAnimation");
var EventBody2EventBodyFloater = /** @class */ (function () {
    function EventBody2EventBodyFloater(ext) {
        this.ext = ext;
        this.conflicts = [];
        /**
         * above EventBody is above, below EventBody is below
         * */
        this.eventBodyList = [];
    }
    EventBody2EventBodyFloater.isConflict = function (eb1, eb2) {
        if (eb1 === eb2)
            return false;
        if (eb1.drawInfo.floated || eb2.drawInfo.floated)
            return false;
        return functions_1.isOverlap(eb1.drawInfo.box, eb2.drawInfo.box);
    };
    EventBody2EventBodyFloater.prototype.float = function (conflicts) {
        return __awaiter(this, void 0, void 0, function () {
            var maxWidthInConflict;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        maxWidthInConflict = Math.max.apply(Math, __spread(conflicts.with.map(function (c) { return c.drawInfo.box.width + c.drawInfo.offset.x; })));
                        conflicts.self.drawInfo.offset.x = maxWidthInConflict + 1;
                        conflicts.self.drawInfo.maxWidth = Math.min(this.timeline.grid.eventWidth, this.axisBody.drawInfo.box.x - maxWidthInConflict);
                        conflicts.self.drawInfo.floated = true;
                        return [4 /*yield*/, conflicts.self.apply()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventBody2EventBodyFloater.prototype.fix = function () {
        return __awaiter(this, void 0, void 0, function () {
            var conflict, eventBodies, options;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.timeline = this.ext.components[definitions_1.SN.Timeline][0];
                        this.axisBody = this.ext.components[definitions_1.SN.AxisBody][0];
                        this.eventBodyList = Array.from(this.ext.components[definitions_1.SN.EventBody])
                            .sort(function (eb1, eb2) {
                            return eb1.drawInfo.markDrawInfo.target.y - eb2.drawInfo.markDrawInfo.target.y;
                        });
                        this.countConflict();
                        if (this.conflicts.length === 0) {
                            return [2 /*return*/, "no-conflict" /* NoConflict */];
                        }
                        conflict = this.pickRingleader();
                        eventBodies = __spread([
                            conflict.self
                        ], conflict.with).sort(function (eb1, eb2) { return eb2.drawInfo.markDrawInfo.target.y - eb1.drawInfo.markDrawInfo.target.y; });
                        options = {
                            components: __spread([
                                this.axisBody
                            ], eventBodies.filter(function (eb) { return !eb.drawInfo.floated; }), eventBodies.filter(function (eb) { return eb.drawInfo.floated; })),
                            protagonist: conflict.self,
                        };
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.FixEventBody2EventBodyFloater, options)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.float(conflict)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.FixEventBody2EventBodyFloater, __assign(__assign({}, options), { forward: true }))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, "alleviated" /* Alleviated */];
                }
            });
        });
    };
    EventBody2EventBodyFloater.prototype.pickRingleader = function () {
        var maxTimes = Math.max.apply(Math, __spread(this.conflicts.map(function (c) { return c.with.length; })));
        var candidates = this.conflicts.filter(function (c) { return c.with.length === maxTimes; });
        if (candidates.length === 0)
            return;
        if (candidates.length === 1)
            return candidates[0];
        candidates.sort(function (c1, c2) {
            var drawInfo1 = c1.self.drawInfo;
            var drawInfo2 = c2.self.drawInfo;
            var descriptionLength1 = drawInfo1.description ? drawInfo1.description.length : 0;
            var descriptionLength2 = drawInfo2.description ? drawInfo2.description.length : 0;
            var titleLength1 = drawInfo1.title ? drawInfo1.title.length : 0;
            var titleLength2 = drawInfo2.title ? drawInfo2.title.length : 0;
            return (descriptionLength1 + titleLength1) - (descriptionLength2 + titleLength2);
        });
        return candidates[0];
    };
    EventBody2EventBodyFloater.prototype.countConflict = function () {
        var e_1, _a;
        this.conflicts.length = 0;
        var _loop_1 = function (eb) {
            var conflict = {
                self: eb,
                with: this_1.ext.components[definitions_1.SN.EventBody].filter(function (target) { return EventBody2EventBodyFloater.isConflict(eb, target); }),
            };
            if (conflict.with.length)
                this_1.conflicts.push(conflict);
        };
        var this_1 = this;
        try {
            for (var _b = __values(this.eventBodyList), _c = _b.next(); !_c.done; _c = _b.next()) {
                var eb = _c.value;
                _loop_1(eb);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    return EventBody2EventBodyFloater;
}());
exports.default = EventBody2EventBodyFloater;
//# sourceMappingURL=EventBody2EventBodyFloater.js.map