"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var functions_1 = require("../../common/functions");
var definitions_1 = require("../../common/definitions");
var BreakpointAnimation_1 = require("../BreakpointAnimation");
var EventBody2EventBodyMover = /** @class */ (function () {
    function EventBody2EventBodyMover(ext) {
        this.ext = ext;
        this.conflicts = [];
        /**
         * above EventBody is above, below EventBody is below
         * */
        this.eventBodyList = [];
        this.spaceMap = new Map;
    }
    EventBody2EventBodyMover.avoid = function (_a) {
        var mover = _a.mover, fixed = _a.fixed, direction = _a.direction;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (direction > 0) {
                            mover.drawInfo.offset.y +=
                                (fixed.drawInfo.box.y + fixed.drawInfo.box.height)
                                    - mover.drawInfo.box.y
                                    + 1;
                        }
                        else {
                            mover.drawInfo.offset.y -=
                                (mover.drawInfo.box.y + mover.drawInfo.box.height)
                                    - fixed.drawInfo.box.y
                                    + 1;
                        }
                        return [4 /*yield*/, mover.apply()];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventBody2EventBodyMover.isConflict = function (eb1, eb2) {
        if (eb1 === eb2)
            return false;
        if (eb1.drawInfo.floated !== eb2.drawInfo.floated) {
            var floated = (eb1.drawInfo.floated ? eb1 : eb2);
            var another = (eb1 === floated ? eb2 : eb1);
            if ( // floated's line overlapped with another's body
            (floated.drawInfo.markDrawInfo.target.y > another.drawInfo.box.y)
                && (floated.drawInfo.markDrawInfo.target.y
                    < (another.drawInfo.box.y + another.drawInfo.box.height)))
                return true;
        }
        return functions_1.isOverlap(eb1.drawInfo.box, eb2.drawInfo.box);
    };
    EventBody2EventBodyMover.prototype.fix = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.eventBodyList = Array.from(this.ext.components[definitions_1.SN.EventBody])
                            .sort(function (eb1, eb2) { return (eb1.drawInfo.markDrawInfo.target.y
                            - eb2.drawInfo.markDrawInfo.target.y); });
                        return [4 /*yield*/, functions_1.walkLoop(function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, this.tryFixOne()];
                                        case 1: return [2 /*return*/, [
                                                _a.sent()
                                            ]];
                                    }
                                });
                            }); })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * @return {boolean} have fixed one of conflicts?
     * */
    EventBody2EventBodyMover.prototype.tryFixOne = function () {
        return __awaiter(this, void 0, void 0, function () {
            var conflict, eventBodies, options;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.countConflict()];
                    case 1:
                        _a.sent();
                        this.countSpace();
                        if (this.conflicts.length === 0)
                            return [2 /*return*/, "no-conflict" /* NoConflict */];
                        this.conflicts = this.conflicts.filter(function (conflict) { return _this.isPossible(conflict); });
                        if (this.conflicts.length === 0)
                            return [2 /*return*/, "failed" /* Failed */];
                        conflict = this.conflicts.find(function (conflict1) { return _this.conflicts.every(function (conflict2) { return _this.countCast(conflict1) <= _this.countCast(conflict2); }); });
                        eventBodies = __spread([
                            conflict.self
                        ], conflict.with).sort(function (eb1, eb2) { return eb2.drawInfo.markDrawInfo.target.y - eb1.drawInfo.markDrawInfo.target.y; });
                        options = {
                            components: __spread(this.ext.components[definitions_1.SN.AxisBody], eventBodies.filter(function (eb) { return !eb.drawInfo.floated; }), eventBodies.filter(function (eb) { return eb.drawInfo.floated; })),
                            protagonist: conflict.self,
                        };
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.FixEventBody2EventBodyMover, options)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.fixConflict(conflict)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.FixEventBody2EventBodyMover, __assign(__assign({}, options), { forward: true }))];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, "alleviated" /* Alleviated */];
                }
            });
        });
    };
    EventBody2EventBodyMover.prototype.isPossible = function (conflict) {
        if (conflict.self.drawInfo.floated
            && conflict.with.some(function (eb) { return !eb.drawInfo.floated; }))
            return false;
        var needed = this.countNeeded(conflict);
        var space = this.spaceMap.get(conflict.self);
        return (needed.bottom === 0 || needed.top === 0)
            && (space.bottom >= needed.bottom && space.top >= needed.top);
    };
    EventBody2EventBodyMover.prototype.fixConflict = function (conflict) {
        return __awaiter(this, void 0, void 0, function () {
            var needed, moveDistance, direction, effectable, i, last, now;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        needed = this.countNeeded(conflict);
                        moveDistance = needed.top ? needed.top : -needed.bottom;
                        direction = moveDistance / Math.abs(moveDistance);
                        // fix conflict
                        conflict.self.drawInfo.offset.y += moveDistance;
                        return [4 /*yield*/, conflict.self.apply()];
                    case 1:
                        _a.sent();
                        effectable = this.eventBodyList.filter(function (eb) { return eb.drawInfo.floated === conflict.self.drawInfo.floated; });
                        i = effectable.indexOf(conflict.self) + direction;
                        _a.label = 2;
                    case 2:
                        if (!(i >= 0 && i < effectable.length)) return [3 /*break*/, 6];
                        last = effectable[i - direction];
                        now = effectable[i];
                        if (!EventBody2EventBodyMover.isConflict(last, now)) return [3 /*break*/, 4];
                        return [4 /*yield*/, EventBody2EventBodyMover.avoid({
                                direction: direction,
                                mover: now,
                                fixed: last,
                            })];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        i += direction;
                        return [3 /*break*/, 2];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    EventBody2EventBodyMover.prototype.countConflict = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _loop_1, this_1, _a, _b, eb;
            var e_1, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        this.conflicts.length = 0;
                        return [4 /*yield*/, Promise.all(this.eventBodyList.map(function (eb) { return eb.apply(); }))];
                    case 1:
                        _d.sent();
                        _loop_1 = function (eb) {
                            var conflict = {
                                self: eb,
                                with: this_1.eventBodyList.filter(function (target) { return EventBody2EventBodyMover.isConflict(eb, target); }),
                            };
                            if (conflict.with.length)
                                this_1.conflicts.push(conflict);
                        };
                        this_1 = this;
                        try {
                            for (_a = __values(this.eventBodyList), _b = _a.next(); !_b.done; _b = _a.next()) {
                                eb = _b.value;
                                _loop_1(eb);
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    EventBody2EventBodyMover.prototype.countCast = function (conflict) {
        var needed = this.countNeeded(conflict);
        return needed.bottom + needed.top;
    };
    /**
     * Count the number how many space needed for fix the conflict by verticalMove
     * */
    EventBody2EventBodyMover.prototype.countNeeded = function (conflict) {
        var origin = conflict.self;
        var result = {
            top: 0,
            bottom: 0,
        };
        var above = conflict.with.filter(function (cb) { return cb.drawInfo.markDrawInfo.target.y < origin.drawInfo.markDrawInfo.target.y; });
        var below = conflict.with.filter(function (cb) {
            return cb.drawInfo.markDrawInfo.target.y > origin.drawInfo.markDrawInfo.target.y;
        });
        if (above.length) {
            result.top = Math.max.apply(Math, __spread(above.map(function (upper) {
                if (upper.drawInfo.floated === origin.drawInfo.floated) {
                    return (upper.drawInfo.box.y
                        + upper.drawInfo.box.height
                        - origin.drawInfo.box.y);
                }
                else if (origin.drawInfo.floated) {
                    return ((upper.drawInfo.box.y + upper.drawInfo.box.height)
                        - origin.drawInfo.markDrawInfo.target.y);
                }
                else if (upper.drawInfo.floated) {
                    return upper.drawInfo.markDrawInfo.target.y - origin.drawInfo.box.y;
                }
                throw SyntaxError('floated is not a boolean');
            })));
        }
        if (below.length) {
            result.bottom = Math.max.apply(Math, __spread(below.map(function (lower) {
                if (lower.drawInfo.floated === origin.drawInfo.floated) {
                    return (origin.drawInfo.box.y
                        + origin.drawInfo.box.height
                        - lower.drawInfo.box.y);
                }
                else if (origin.drawInfo.floated) {
                    return origin.drawInfo.markDrawInfo.target.y - lower.drawInfo.box.y;
                }
                else if (lower.drawInfo.floated) {
                    return ((origin.drawInfo.box.y + origin.drawInfo.box.height)
                        - lower.drawInfo.markDrawInfo.target.y);
                }
                throw SyntaxError('floated is not a boolean');
            })));
        }
        // margin 1 to target of conflict
        if (result.top)
            result.top++;
        if (result.bottom)
            result.bottom++;
        origin.extraData.needed = result;
        return result;
    };
    /**
     * Count the number how many space the component can move
     * */
    EventBody2EventBodyMover.prototype.countSpace = function () {
        var _this = this;
        var spacePadding = 4; // FIXME: remove supported
        // Itself's can move space
        this.eventBodyList.forEach(function (eb) { return _this.spaceMap.set(eb, {
            top: eb.drawInfo.markDrawInfo.target.y - eb.drawInfo.box.y - spacePadding,
            bottom: eb.drawInfo.box.y
                + eb.drawInfo.box.height
                - eb.drawInfo.markDrawInfo.target.y
                - spacePadding,
        }); });
        var applyLimiting = function (allEventBody) {
            if (allEventBody.length === 0)
                return;
            // An item is limited from
            // it's first that prevent out of canvas
            var first = allEventBody[0];
            _this.spaceMap.get(first).bottom = Math.min(_this.spaceMap.get(first).bottom, first.drawInfo.box.y);
            // it's last that prevent out of canvas
            var last = allEventBody[allEventBody.length - 1];
            _this.spaceMap.get(last).top = Math.min(_this.spaceMap.get(last).top, last.canvas.height - (last.drawInfo.box.y + last.drawInfo.box.height));
            // clamp by neighbor
            for (var i = 1; i < allEventBody.length; i++) {
                var previous = allEventBody[i - 1];
                var now = allEventBody[i];
                var nowData = _this.spaceMap.get(now);
                var previousData = _this.spaceMap.get(previous);
                var distance = now.drawInfo.box.y -
                    (previous.drawInfo.box.y + previous.drawInfo.box.height);
                nowData.bottom = Math.min(nowData.bottom, distance + previousData.bottom);
            }
            for (var i = allEventBody.length - 2; i >= 0; i--) {
                var next = allEventBody[i + 1];
                var now = allEventBody[i];
                var nowData = _this.spaceMap.get(now);
                var nextData = _this.spaceMap.get(next);
                var distance = next.drawInfo.box.y -
                    (now.drawInfo.box.y + now.drawInfo.box.height);
                nowData.top = Math.min(nowData.top, distance + nextData.top);
            }
            // Set number which < 0 as 0
            Array.from(_this.spaceMap.values()).forEach(function (value) {
                value.top = Math.max(0, value.top);
                value.bottom = Math.max(0, value.bottom);
            });
        };
        applyLimiting(this.eventBodyList.filter(function (eb) { return eb.drawInfo.floated; }));
        applyLimiting(this.eventBodyList.filter(function (eb) { return !eb.drawInfo.floated; }));
        this.eventBodyList.forEach(function (eb) { return eb.extraData.space = _this.spaceMap.get(eb); });
    };
    return EventBody2EventBodyMover;
}());
exports.default = EventBody2EventBodyMover;
//# sourceMappingURL=EventBody2EventBodyMover.js.map