import { Extension, ExtensionManager, ExtensionType } from '.';
import Component from '../common/Component';
/**
 * 1. Set a id for every Component in component.extraData.id.
 * 2. Create a global variable using component's id if DEBUG is true when comp.apply been fired
 * */
export default class IdGenerator implements Partial<Extension> {
    ext: ExtensionManager;
    constructor(ext: ExtensionManager);
    type: ExtensionType;
    /**
     * Set component.extraData.id
     * */
    onConstruct(comp: Component): void;
    /**
     * If the DEBUG is true, set a global variable using component.extraData.id in windows
     * to point the component.
     * */
    onApply(comp: Component): Promise<void>;
}
