"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var definitions_1 = require("../common/definitions");
var Axis_1 = __importDefault(require("../Axis"));
var AxisBody_1 = __importDefault(require("../Axis/AxisBody"));
var AxisScale_1 = __importDefault(require("../Axis/AxisScale"));
var AxisMilestone_1 = __importDefault(require("../Axis/AxisMilestone"));
var Event_1 = __importDefault(require("../Event"));
var EventBody_1 = __importDefault(require("../Event/EventBody"));
var EventMark_1 = __importDefault(require("../Event/EventMark"));
var EventAxis_1 = __importDefault(require("../Event/EventAxis"));
var BreakpointAnimation_1 = __importDefault(require("./BreakpointAnimation"));
exports.BreakpointAnimation = BreakpointAnimation_1.default;
var BoxElementGenerator_1 = __importDefault(require("./BoxElementGenerator"));
exports.BoxElementGenerator = BoxElementGenerator_1.default;
var IdGenerator_1 = __importDefault(require("./IdGenerator"));
exports.IdGenerator = IdGenerator_1.default;
var PositionCounter_1 = __importDefault(require("./PositionCounter"));
exports.PositionCounter = PositionCounter_1.default;
var ConflictFixer_1 = __importDefault(require("./ConflictFixer"));
exports.ConflictFixer = ConflictFixer_1.default;
/**
 * @property {string} Debug - enable the extension both normal and disableAllButDebug
 * @property {string} DebugOnly - enable the extension only the debug is true
 * */
var ExtensionType;
(function (ExtensionType) {
    ExtensionType["Debug"] = "debug";
    ExtensionType["DebugOnly"] = "debug-only";
})(ExtensionType = exports.ExtensionType || (exports.ExtensionType = {}));
var METHODS = ['onConstruct', 'onApply', 'onDestroy', 'onHide', 'onDraw'];
/**
 * Manage ExtensionManager#components.
 * */
var Base = /** @class */ (function () {
    function Base(ext) {
        this.ext = ext;
    }
    Base.prototype.onConstruct = function (comp) {
        this.ext.components[comp.name].push(comp);
    };
    Base.prototype.onDestroy = function (comp) {
        this.ext.components[comp.name].splice(this.ext.components[comp.name].indexOf(comp), 1);
    };
    return Base;
}());
exports.Base = Base;
var ExtensionManager = /** @class */ (function () {
    function ExtensionManager(_a) {
        var _b;
        var _c = _a === void 0 ? {} : _a, breakpointAnimation = _c.breakpointAnimation, _d = _c.disableAll, disableAll = _d === void 0 ? false : _d, _e = _c.disableAllButDebug, disableAllButDebug = _e === void 0 ? false : _e;
        /**
         * A shared object for every Component.
         * For extends, re-declare the ExtData.
         * */
        this.extraData = {};
        this.components = (_b = {},
            _b[definitions_1.SN.Timeline] = [],
            _b[definitions_1.SN.Axis] = [],
            _b[definitions_1.SN.AxisBody] = [],
            _b[definitions_1.SN.AxisScale] = [],
            _b[definitions_1.SN.AxisMilestone] = [],
            _b[definitions_1.SN.Event] = [],
            _b[definitions_1.SN.EventBody] = [],
            _b[definitions_1.SN.EventMark] = [],
            _b[definitions_1.SN.EventAxis] = [],
            _b);
        this.onConstruct = createHandler('onConstruct', this);
        this.onApply = createHandler('onApply', this);
        this.onHide = createHandler('onHide', this);
        this.onDraw = createHandler('onDraw', this);
        this.onDestroy = createHandler('onDestroy', this);
        this.disableAll = disableAll;
        this.disableAllButDebug = disableAllButDebug;
        this.breakpoint = new BreakpointAnimation_1.default(this, breakpointAnimation);
        this.extensions = [
            new Base(this),
            new IdGenerator_1.default(this),
            new BoxElementGenerator_1.default(this),
            new PositionCounter_1.default(this),
            new ConflictFixer_1.default(this),
            this.breakpoint,
        ];
    }
    ExtensionManager.prototype.getParent = function (comp) {
        if (Axis_1.default.is(comp))
            return this.components[definitions_1.SN.Timeline][0];
        if (Event_1.default.is(comp))
            return this.components[definitions_1.SN.Timeline][0];
        if (AxisBody_1.default.is(comp))
            return this.components[definitions_1.SN.Axis][0];
        if (AxisMilestone_1.default.is(comp))
            return this.components[definitions_1.SN.Axis][0];
        if (AxisScale_1.default.is(comp))
            return this.components[definitions_1.SN.Axis][0];
        if (EventBody_1.default.is(comp))
            return this.components[definitions_1.SN.Event].find(function (event) { return event.body === comp; });
        if (EventAxis_1.default.is(comp))
            return this.components[definitions_1.SN.Event].find(function (event) { return event.axis === comp; });
        if (EventMark_1.default.is(comp))
            return this.components[definitions_1.SN.Event].find(function (event) { return event.mark === comp; });
        throw new TypeError("Cannot find parent of " + comp.constructor.name);
    };
    return ExtensionManager;
}());
exports.ExtensionManager = ExtensionManager;
function createHandler(methodName, ext) {
    return function extensionManagerMethod(comp) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, extension, e_1_1;
            var e_1, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (ext.disableAll)
                            return [2 /*return*/];
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 7, 8, 9]);
                        _a = __values(ext.extensions), _b = _a.next();
                        _d.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 6];
                        extension = _b.value;
                        if (extension.type === ExtensionType.DebugOnly && !definitions_1.DEBUG)
                            return [3 /*break*/, 5];
                        if (ext.disableAllButDebug) {
                            if (!definitions_1.DEBUG)
                                return [3 /*break*/, 5];
                            if (!extension.type)
                                return [3 /*break*/, 5];
                            if (![ExtensionType.DebugOnly, ExtensionType.Debug].includes(extension.type))
                                return [3 /*break*/, 5];
                        }
                        if (!(methodName in extension)) return [3 /*break*/, 5];
                        if (!(methodName === 'onApply')) return [3 /*break*/, 4];
                        return [4 /*yield*/, extension[methodName](comp)];
                    case 3:
                        _d.sent(); // eslint-disable-line no-await-in-loop
                        return [3 /*break*/, 5];
                    case 4:
                        extension[methodName](comp);
                        _d.label = 5;
                    case 5:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
}
//# sourceMappingURL=index.js.map