import { ExtensionManager } from './extensions';
export interface Coordinate {
    x: number;
    y: number;
}
export interface Box extends Coordinate {
    width: number;
    height: number;
}
export interface Line {
    startX: number;
    startY: number;
    endX: number;
    endY: number;
}
export declare const enum DateBy {
    FiveCentury = "fiveCentury",
    Century = "century",
    TenYear = "tenYear",
    Year = "year",
    Month = "month",
    Quarter = "quarter",
    Week = "week",
    Day = "day"
}
/**
 * The box in the Container and the Canvas of component.
 * The box should contain all trace of component.
 * */
export interface ComponentDrawInfo {
    box: Box;
}
/**
 * All component's config of what style to draw.
 * E.g. The border width of Axis.
 * Must be filled before apply() called.
 * todo: add description about props
 * */
export interface GridConfig {
    eventOffset: Coordinate;
    minEventAxisOffset: number;
    markWidth: number;
    markHeight?: number;
    scaleHeight: number;
    axisWidth: number;
    axisStart: Coordinate;
    eventWidth: number;
    canvasWidth: number;
}
export declare const enum ConflictFixResult {
    Failed = "failed",
    Alleviated = "alleviated",
    NoConflict = "no-conflict"
}
export interface ComponentConstructorInfo {
    ext: ExtensionManager;
    canvas: HTMLCanvasElement;
    container: HTMLElement;
}
export declare type TimelineData = any;
